/* File FLGA.H  Header file for fuzzy logic - genetic algorithm system */

#ifndef FLGA_H
#define FLGA_H

#include "uttypes.h"
#include "ga.h"
#include "flogic.h"

typedef struct {
   int no_of_fl_inputs,
       no_of_fl_inp_regions,
       no_of_fl_output_values;
   short read_in_fuzzy_system;
   float norm_in_range,norm_in_min,
	 norm_out_range,norm_out_min;
   path_str fuzzy_system_file_name,
	 training_file_name,
	 out_data_file_name;
   } tflg_setup_rec;

extern tflg_setup_rec g_flg_rec;

/*  File FLGINIT.C */
void init_flga_setup (tflg_setup_rec *fl);
void init_flga_fuzzy_system (tflg_setup_rec fl,fuzzy_system_rec *fz);

/*  File FLGEVAL.C */
void ga_vector_to_fuzzy_rules (ui_vector v,fuzzy_system_rec *fz);
float fl_evaluation_fn (ui_vector v);

/*  File FLGTRAIN.C  */
void fl_genetic_training (tflg_setup_rec *fl,tga_setup_rec *ga_setup,
	tga_rec *ga);

/*  File FLGRUN.C  */
void run_fuzzy_model (tflg_setup_rec fl);

#endif