// File HOPSETUP.CPP Set up Turbo Vision interface for
//      Hopfield Associative Memory Network

#ifndef HOPSETUP_CPP
#define HOPSETUP_CPP

#include <conio.h>
#include <string.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <io.h>

#include "uisetup.cpp"

extern "C" {
  #include "hop.h"
  }

class thopsetapp : public TSetApp
   {
   public :
     thopsetapp();
     virtual void setup();
     virtual void data_file_setup();
     static TMenuBar *initMenuBar (TRect r );
     static void init_submenus();
     virtual char *save_setup (char *the_file_name);
     virtual char *read_setup (char *the_file_name);
   };

void hop_setup_to_collection (hop_setup_rec *the_hop_setup,
   TDataCollection *the_collection)
   {
      void * value_ptr = NULL;
      tdata_type the_type;
      unsigned short len;
      boolean the_check = TRUE;
      unsigned short dec_places = 0;
      float the_max = 0.0;
      float the_min = 0.0;
      boolean enable = TRUE;
      int item_no = 0;

   value_ptr = &the_hop_setup->files.in_wts_file_name;
   the_type = PATH_DATA;
   len = 30;
   dec_places = 0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Weights File Name",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"*.WTS",item_no));

   value_ptr = &the_hop_setup->files.data_file_name;
   the_type = PATH_DATA;
   len = 30;
   dec_places = 0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Exemplar Data File Name",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"*.DAT",item_no));

   value_ptr = &the_hop_setup->no_of_patterns;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = MAX_NO_OF_PATTERNS;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "No. of Patterns",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_hop_setup->no_of_rows;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = MAX_NO_OF_PATTERN_ROWS;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "No. of Pattern Rows",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_hop_setup->no_of_cols;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = MAX_NO_OF_PATTERN_COLS;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "No. of Pattern Cols",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));
   return;
   }

void pattern_data_setup_to_collection (hop_setup_rec *the_hop_setup,
   TDataCollection *the_collection)
   {
      void * value_ptr = NULL;
      tdata_type the_type;
      unsigned short len;
      boolean the_check = TRUE;
      unsigned short dec_places = 0;
      float the_max = 0.0;
      float the_min = 0.0;
      boolean enable = TRUE;
      int item_no = 0;

   value_ptr = &the_hop_setup->files.data_file_name;
   the_type = PATH_DATA;
   len = 30;
   dec_places = 0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "Input Data File Name",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"*.DAT",item_no));

   value_ptr = &the_hop_setup->files.new_data_file_name;
   the_type = PATH_DATA;
   len = 30;
   dec_places = 0;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "New/Edited Data File Name",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"*.DAT",item_no));

   value_ptr = &the_hop_setup->no_of_patterns;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = MAX_NO_OF_PATTERNS;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "No. of Patterns",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_hop_setup->no_of_rows;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = MAX_NO_OF_PATTERN_ROWS;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "No. of Pattern Rows",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));

   value_ptr = &the_hop_setup->no_of_cols;
   the_type = INT_DATA;
   len = 2;
   dec_places = 0;
   the_max = MAX_NO_OF_PATTERN_COLS;
   the_min = 1;
   item_no++;
   the_collection->insert (new tcolor_data_obj (
	 "No. of Pattern Cols",
	 value_ptr,the_type,len,the_check,dec_places,the_max,the_min,
	 enable,"",item_no));
   return;
   }

thopsetapp::thopsetapp() : TSetApp(),
   TProgInit (&thopsetapp::initStatusLine,
	      &thopsetapp::initMenuBar,
	      &thopsetapp::initDeskTop
	      )
   {
   hop_setup_to_collection (&g_hop_rec,system_setup_data.item_collection);
   pattern_data_setup_to_collection (&g_hop_rec,
	 training_setup_data.item_collection);
   if (quit_flag == startup) about_dialog();
   }

 void thopsetapp::init_submenus()
   {
   TSetApp::init_submenus();
   // Skip training setup items:
   train_submenu->subMenu->items = train_item;
   train_submenu->subMenu->deflt = train_item;
   return;
   }

TMenuBar *thopsetapp::initMenuBar ( TRect r )
{
   r.b.y = r.a.y + 1;  //Set bottom line 1 line below top line
   init_submenus();
   return new TMenuBar (r,new TMenu(*about_submenu));
 }

void special_processing(tlist_box_data *the_data_rec,int item_no)
   {
   ((tcolor_data_obj *) (the_data_rec->item_collection)->at(item_no - 1))
     ->get_new_value();
   //  Update pattern data
   g_pattern_data.no_of_patterns = g_hop_rec.no_of_patterns;
   g_pattern_data.no_of_rows = g_hop_rec.no_of_rows;
   g_pattern_data.no_of_cols = g_hop_rec.no_of_cols;
   g_pattern_data.no_of_nodes = g_pattern_data.no_of_rows *
      g_pattern_data.no_of_cols;
   strcpy (g_hop_rec.files.out_wts_file_name,
      g_hop_rec.files.in_wts_file_name);
   return;
   }

void thopsetapp::setup()
   {
   list_dialog ("SETUP PARAMETERS","",&system_setup_data,
     MAX_NO_OF_SETUP_ITEMS,&special_processing);
   return;
   }

void thopsetapp::data_file_setup()
   {
   list_dialog ("DATA SETUP","",&training_setup_data,
     MAX_NO_OF_SETUP_ITEMS,&special_processing);
   return;
   }

char *thopsetapp::save_setup (char *the_file_name)
   {
   write_record (the_file_name,(void *)&g_hop_rec,sizeof(g_hop_rec));
   return the_file_name;
   }

char *thopsetapp::read_setup (char *the_file_name)
   {
   read_record (the_file_name,(void *)&g_hop_rec,sizeof(g_hop_rec));
   return the_file_name;
   }

#endif