/* File UTGR.H  Graphics utilities header */
/*  Note: The graphics utilities use Borland's graphics.h library,
/*  and so are not ANSI C compatible.  */

#ifndef UTGR_H
#define UTGR_H

#include <graphics.h>

typedef struct {
   float x_min,x_max,y_min,y_max;
   int max_mode;
   short scale_window_from_data;
   short label_axes;
   char x_axis_label,y_axis_label;
   short line_color,text_color,back_color;
   } graph_setup_rec;

#define X_MIN_INIT 0.0
#define X_MAX_INIT 1.0
#define Y_MIN_INIT 0.0
#define Y_MAX_INIT 1.0
#define MAX_MODE_INIT VGAHI
#define SCALE_WINDOW_FROM_DATA_INIT 1
#define LABEL_AXES_INIT 0
#define X_AXIS_LABEL_INIT ' '
#define Y_AXIS_LABEL_INIT ' '
#define LINE_COLOR_INIT LIGHTCYAN
#define TEXT_COLOR_INIT YELLOW
#define BACK_COLOR_INIT BLACK

extern float gr_x_min,gr_y_min,gr_x_max,gr_y_max,gr_x_range,gr_y_range;
extern int graphdriver,graphmode;
extern int gr_start_col,gr_end_col,
       gr_start_row,gr_end_row,
       gr_no_of_rows,gr_no_of_cols,
       gr_iter_row_1,gr_iter_row_2,
       gr_iter_col,gr_done_row,
       gr_x_min_col,gr_x_max_col,gr_x_row,
       gr_y_min_row,gr_y_max_row,gr_y_col;
extern graph_setup_rec gr_graph_setup;

short graph_setup (graph_setup_rec the_setup);
void draw_border(graph_setup_rec gr_setup);
void graph_x_y_labels (graph_setup_rec gr_setup);
void graph_iter (graph_setup_rec gr_setup,unsigned long iter);
short xy_to_screen_col_row (float x,float y,int *col,int *row);
void xy_to_screen (float x,float y,int color);

#endif